using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Muell
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(56, 24);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "Go";
			this.button1.Click += new System.EventHandler(this.RequestButton_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(184, 69);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private	int					daysBack	= 0;
		private IESignal.HooksClass eSignal		= new IESignal.HooksClass();

		private void eSignal_OnBarsChanged(int lHandle)
		{
			eSignal.ReleaseHistory(lHandle);
			RequestHistory();
		}

		private void eSignal_OnBarsReceived(int lHandle)
		{
			eSignal.ReleaseHistory(lHandle);
			RequestHistory();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			eSignal.SetApplication("trademagic");

			// this is another eSignal bug: you may not query for IsEntitled immediately 
			// after calling SetApplication. You have to wait some seconds: here max = 10 seconds
			int milliSeconds = 0;
			for ( ; milliSeconds < 10 * 1000; milliSeconds += 10)
			{
				if (eSignal.IsEntitled != 0)
					break;
				System.Threading.Thread.Sleep(10);
				System.Windows.Forms.Application.DoEvents();
			}

			if (eSignal.IsEntitled == 0)
			{
				MessageBox.Show("Not entitled");
				return;
			}

			// clear any eSignal internal cache
			eSignal.ClearSymbolCache();
			eSignal.ReleaseAllHistory();
			eSignal.ReleaseAllTimeSales();

			eSignal.OnBarsChanged += new IESignal._IHooksEvents_OnBarsChangedEventHandler(eSignal_OnBarsChanged);
			eSignal.OnBarsReceived += new IESignal._IHooksEvents_OnBarsReceivedEventHandler(eSignal_OnBarsReceived);
			MessageBox.Show("Connected");
		}

		private void RequestButton_Click(object sender, System.EventArgs e)
		{
			RequestHistory();
		}

		private void RequestHistory()
		{
			// request 10 more days back
			daysBack += 10;

			MessageBox.Show("requesting " + daysBack + " days of data");
			int handle = eSignal.get_RequestHistory("MSFT", "D", IESignal.barType.btDAYS, daysBack, -1, -1);
			if (eSignal.get_IsHistoryReady(handle) == 1)
			{
				if (eSignal.get_GetNumBars(handle) == 0)
				{
					// !!! here is the problem: !!!
					// although eSignal says, that history is ready, there are no bars
					MessageBox.Show("this is the problem");
					System.Windows.Forms.Application.Exit();
				}
				eSignal.ReleaseHistory(handle);
				RequestHistory();
			}
		}
	}
}
